(********************************************************************)
(* SessML - Examples                                                *)
(*                                                                  *)
(* seller.ml                                                        *)
(********************************************************************)
(* Time-stamp: <Deniélou Malo - 2011> *)

open Runtime
open Prins
open BuyerBrokerSeller

let () = register {id="dave";ip="127.0.0.1";port=8054}
let () = register {id="charlie";ip="127.0.0.1";port=8053}

let () = Global.set_debug_com true
let () = Global.set_debug_com_io true
let () = Global.set_debug_impl true
let () = Global.set_debug_runtime true

let _ = 
  let protocol = 
    {hOrder = function title -> (
      OrderFwd(title,
            {hQuote = function q -> (
              QuoteFwd(q,
                    {hOK = (fun _ -> 
                      OKFwd((),
                         {hInvoice = fun i ->
                           InvoiceFwd(i,
                                   {hPayment = fun p ->
                                     PaymentFwd(p,"Ok")})})
                     );
                     hNOTOK = (fun _ ->
                       NOTOKFwd((),
                             {hFeedback = fun f ->
                               FeedbackFwd(f,"Not Ok")})
                     )}
              ))}))}
  in
  let res = broker "charlie" "dave" protocol
  in
  Printf.printf "Finished with %s\n" res
