(********************************************************************)
(* SessML - Examples                                                *)
(*                                                                  *)
(* buyer.ml                                                         *)
(********************************************************************)
(* Time-stamp: <Deniélou Malo - 2011> *)

open Runtime
open Prins
open BuyerBrokerSeller

let () = register {id="alice";ip="127.0.0.1";port=8051}
let () = register {id="charlie";ip="127.0.0.1";port=8050}

let () = set_amqp_port 5674
let () = Global.set_debug_com true
let () = Global.set_debug_com_io false
let () = Global.set_debug_impl true
let () = Global.set_debug_runtime true

let _ = 
  let client_port =
    if Array.length (Sys.argv) = 2 
    then (int_of_string (Sys.argv.(1)))
    else 5672
  in
  let () = set_amqp_port client_port in
  let protocol = 
    Order ("TAPL",
           {hQuoteFwd= function price ->
              if price > 42
              then NOTOK ((),Feedback("Too expensive!",price))
              else OK ((),
                       {hInvoiceFwd = fun inv -> 
			   Payment ("VISA XXXXXXXXX",price)})
           })
  in
  let res = buyer "charlie" "alice" protocol
  in
  Printf.printf "Finished with %d\n" res
