(********************************************************************)
(* SessML - Examples                                                *)
(*                                                                  *)
(* seller.ml                                                        *)
(********************************************************************)
(* Time-stamp: <Deniélou Malo - 2011> *)

open Runtime
open Prins
open BuyerBrokerSeller

let () = register {id="alice";ip="127.0.0.1";port=8051}
let () = register {id="bob";ip="127.0.0.1";port=8052}

let () = Global.set_debug_com true
let () = Global.set_debug_com_io true
let () = Global.set_debug_impl true
let () = Global.set_debug_runtime true

let _ = 
  let protocol = 
    {hOrderFwd = function title -> (
      let price =
        if title = "TAPL" 
        then 25
        else 50 in
      Quote(price,
            {hOKFwd = (fun _ -> Invoice("Invoice!",
                                     {hPaymentFwd= fun _ -> "Payed!"}));
             hNOTOKFwd = (fun _ -> {hFeedbackFwd = fun reason -> reason})})
    )}
  in
  let res = seller "charlie" "bob" protocol
  in
  Printf.printf "Finished with %s\n" res
