(********************************************************************)
(* SessML - Examples                                                *)
(*                                                                  *)
(* seller.ml                                                        *)
(********************************************************************)
(* Time-stamp: <Pierre-Malo Denielou - 2011> *)

open Runtime
open Prins
open BuyerSeller

let () = register {id="alice";ip="127.0.0.1";port=8051}
let () = register {id="bob";ip="127.0.0.1";port=8052}

let () = Global.set_debug_com true
let () = Global.set_debug_com_io true
let () = Global.set_debug_impl true
let () = Global.set_debug_runtime true

let _ = 
  let protocol = 
    {hTitle = function title -> (
       let price =
         if title = "TAPL" 
         then 25
         else 50 in
       Quote(price,
             {hAccept = (fun _ -> { hAddress = fun s -> Date("Tomorrow","Sold!")});
              hQuit = (fun _ -> "Nothing")})
     )}
  in
  let res = seller "charlie" "bob" protocol
  in
  Printf.printf "Finished with %s\n" res
