(********************************************************************)
(* SessML - Examples                                                *)
(*                                                                  *)
(* client1.ml                                                       *)
(********************************************************************)
(* Time-stamp: <Deniélou Malo - 2010> *)

open Runtime
open Prins
open PeerToPeerChat

let () = register {id="alice";ip="127.0.0.1";port=8051}
let () = register {id="charlie";ip="127.0.0.1";port=8050}

let nop () = () 

let () = 
  let rec continuation n =
    ((fun () -> ((fun x -> Msg("Greetings to "^x^" from alice",())),nop)),
     (fun () -> ((fun x -> {hMsg=fun s -> Printf.printf "**************\nReceived %s\n**************\n" s}),nop)),
     (fun _ -> Printf.printf "Iteration nb %d\n" n ; 
        if n>=15 then Quit_as_client n
        else 
       (* Quit_as_client 42 *)
          Continue_as_client (continuation (n+1))
     ))
  in
  let res = client "charlie" "alice" (continuation 1)
  in
  Printf.printf "Finished with %d\n" res
