(********************************************************************)
(* SessML - Examples                                                *)
(*                                                                  *)
(* client2.ml                                                       *)
(********************************************************************)
(* Time-stamp: <Deniélou Malo - 2010> *)

open Runtime
open Prins
open PeerToPeerChat

let () = register {id="bob";ip="127.0.0.1";port=8052}
let () = register {id="charlie";ip="127.0.0.1";port=8050}

let nop () = () 

let fork f g h = (f,g,h)

let poll f = fun () -> (f,nop)

let () = 
  let rec continuation n =
    fork
      (poll (fun x -> Msg("Greetings to "^x^" from bob",())))
      (poll (fun x -> {hMsg=fun s -> Printf.printf "**************\nReceived %s\n**************\n" s}))
      (fun _ -> Printf.printf "Iteration nb %d\n" n ; 
        if n>=15 then Quit_as_client n
        else Continue_as_client (continuation (n+1)))
  in
  let res = client "charlie" "bob" (continuation 1) 
  in Printf.printf
  "***************\nFinished with %d\n***************\n" res



(*
    ((fun () -> ((fun x -> Msg(x,())),nop)),
     (fun () -> ((fun x -> {hMsg=fun s -> Printf.printf "Received %s\n" s}),nop)),
     (fun _ -> Printf.printf "Iteration nb %d\n" n ; Continue_as_client (continuation (n+1))))
  in
*)
