(********************************************************************)
(* SessML - Examples                                                *)
(*                                                                  *)
(* client2.ml                                                       *)
(********************************************************************)
(* Time-stamp: <Pierre-Malo Denielou - 2010> *)

open Runtime
open Prins
open PeerToPeerChat

let () = register {id="dave";ip="127.0.0.1";port=8053}
let () = register {id="charlie";ip="127.0.0.1";port=8050}

let nop () = () 

let fork f g h = (f,g,h)

let poll f = fun () -> (f,nop)

let () = 
  let rec continuation n =
    fork
      (poll (fun x -> Msg("Greetings to "^x^" from dave",())))
      (poll (fun x -> {hMsg=fun s -> Printf.printf "**************\nReceived %s\n**************\n" s}))
      (fun _ -> Printf.printf "Iteration nb %d\n" n ; 
         if n>=5 then Quit_as_client n
         else Continue_as_client (continuation (n+1)))
  in
  let res = client "charlie" "dave" (continuation 1) 
  in Printf.printf
  "***************\nFinished with %d\n***************\n" res


