(********************************************************************)
(* SessML - Examples                                                *)
(*                                                                  *)
(* customer.ml                                                      *)
(********************************************************************)
(* Time-stamp: <Deniélou Malo - 2011> *)

open Runtime
open Prins
open Streaming

let () = register {id="alice";ip="127.0.0.1";port=8051}
let () = register {id="charlie";ip="127.0.0.1";port=8050}

let () = set_amqp_port 5672
let () = Global.set_debug_com true
let () = Global.set_debug_impl true

let _ = 
  let rec continuation = 
    {hData = (function s -> print_string s ; continuation);
     hEOF = fun _ -> ()}
  in
  let protocol = 
    File ("test.txt", continuation)
  in
  let () = customer "charlie" "alice" protocol
  in
  Printf.printf "\nReceived!\n"
