(********************************************************************)
(* SessML - Examples                                                *)
(*                                                                  *)
(* seller.ml                                                        *)
(********************************************************************)
(* Time-stamp: <Deniélou Malo - 2011> *)

open Runtime
open Prins
open Streaming

let () = register {id="alice";ip="127.0.0.1";port=8051}
let () = register {id="bob";ip="127.0.0.1";port=8052}

let () = Global.set_debug_com true
let () = Global.set_debug_impl true
let () = Global.set_debug_runtime false

let files =
  ["test.txt", "Here is the content"
(* "Here is the content of my file." *)]

(*  It is not very long but it is long enough ...\n *)

let _ =
  let rec stream f i n =
    if i<n then Data(String.sub f i 1,(stream f (i+1) n))
    else EOF((),()) in
  let protocol = 
    {hFile = function title -> (Thread.delay 5.0;
       let f = List.assoc title files in
       stream f 0 (String.length f)
     )}
  in
  let () = seller "charlie" "bob" protocol
  in
  Printf.printf "Finished!\n"
